diff --git a/drivers/nand/nand_base.c b/drivers/nand/nand_base.c
index b7a5d32..cf82d81 100644
--- a/drivers/nand/nand_base.c
+++ b/drivers/nand/nand_base.c
@@ -2150,9 +2150,8 @@ int nand_erase_nand (struct mtd_info *mt
 #ifndef NAND_ALLOW_ERASE_ALL
 		/* Check if we have a bad block, we do not erase bad blocks ! */
 		if (nand_block_checkbad(mtd, ((loff_t) page) << this->page_shift, 0, allowbbt)) {
-			printk (KERN_WARNING "nand_erase: attempt to erase a bad block at page 0x%08x\n", page);
-			instr->state = MTD_ERASE_FAILED;
-			goto erase_exit;
+			printk (KERN_NOTICE "nand_erase: skipping erase of bad block at page 0x%08x\n", page);
+			goto next_page;
 		}
 #endif
 		/* Invalidate the page cache, if we erase the block which contains
@@ -2172,6 +2171,7 @@ #endif
 			goto erase_exit;
 		}
 
+next_page:
 		/* Increment page address and decrement length */
 		len -= (1 << this->phys_erase_shift);
 		page += pages_per_block;
